package com.delfines.dao;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.time.ZonedDateTime;
import java.time.format.DateTimeFormatter;

import javax.naming.InitialContext;

import org.apache.tomcat.jdbc.pool.DataSource;
import org.apache.tomcat.jdbc.pool.PoolProperties;

public final class ConnectionFactoryOperaBat {
	
	public static final String URL = "jdbc:oracle:thin:opera/opera@10.0.0.185:1521:opera";
	
	private static ConnectionFactoryOperaBat instance;
    private Connection connection;

    private ConnectionFactoryOperaBat() {
        this.connect();
    }
	
	public static ConnectionFactoryOperaBat getInstance() {
        if (ConnectionFactoryOperaBat.instance == null) {
        	ConnectionFactoryOperaBat.instance = new ConnectionFactoryOperaBat();
        }
        return ConnectionFactoryOperaBat.instance;
    }
	
	private void connect() {
        try {
        	Class.forName("oracle.jdbc.driver.OracleDriver");  
			this.connection=DriverManager.getConnection(URL);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
	
	public Connection getConnection() {
		try {
			this.connection=DriverManager.getConnection(URL);
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return this.connection;
    }
   
    public static void main(String[] args) {
    	String fecha=""; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactoryOperaBat.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("select sysdate as hoy from dual ");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	fecha=rs.getString("hoy");
            }
            System.out.println(fecha);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
    }
	
	
}
