package com.delfines.spring.controller;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import com.delfines.Constante;
import com.delfines.dao.ConnectionFactoryOperaBat;
import com.delfines.dao.ConnectionFactorySQLAWS;

public class LoadDataBedsOpera2SQLAWS {

	public static void main(String[] args) {
	   try{
		   LoadDataBedsOpera2SQLAWS load=new LoadDataBedsOpera2SQLAWS();
		   Integer qty=load.loadAvailabilityBeds(45);
		   if(qty>0){
			   load.enableBedAvailability();
		   }
		   System.out.println("Inserted "+qty);
	   }catch(Exception e){
		   e.printStackTrace();
	   }
	}
	
	public Integer loadAvailabilityBeds(Integer days)throws Exception{
		Integer qty = 1; 
		
		ResultSet rs=null;
		Statement stmt=null;
		Connection conn=null;
		
        try {
        	conn = ConnectionFactoryOperaBat.getInstance().getConnection();
        	
            StringBuilder query = new StringBuilder();
            query.append(" SELECT MAX(t.n) n,t.business_date,t.categoria,SUM(t.capacidad) capacity,SUM(t.ocupability) ocupability, SUM(t.capacidad-t.ocupability)  availability FROM ( "); 
	            query.append(" SELECT ns.n,to_char((pms_p.business_date+ns.n-1),'DD/MM/RRRR') business_date,c.label categoria,c.capacidad,0 ocupability ");  
	            query.append(" FROM number_scale ns "); 
	            query.append(" INNER JOIN (  ");
		            query.append(" SELECT c.label,count(1) capacidad  FROM ( ");
			            query.append(" SELECT HLD_GET_CANT_BEDS(r.room_category,r.room) label ");
			            query.append(" FROM OPERA.ROOM r     ");
			            query.append(" WHERE r.SUITE_TYPE<>'PSUEDO' "); 
			            query.append(" and r.room_status<>'OO' "); 
		            query.append(" ) c GROUP BY c.label "); 
	            query.append(" ) c ON (1=1)  ");
	            query.append(" WHERE ns.n <= ( (pms_p.business_date+").append(days).append(") - pms_p.business_date+1) "); 
	            query.append(" UNION ALL "); 
	            query.append(" SELECT 0 n,t.considered_date,t.label categoria,0 capacidad,SUM(t.ocupability) ocupability from (  ");
		            query.append(" SELECT TO_CHAR(a.CONSIDERED_DATE,'DD/MM/RRRR') CONSIDERED_DATE,HLD_GET_CANT_BEDS(b.room_category,b.room) label,1  ocupability ");
		            query.append(" FROM  reservation_summary a,reservation_general_view_hld b  ");
		            query.append(" where (a.CONSIDERED_DATE BETWEEN pms_p.business_date and pms_p.business_date+").append(days).append(") and  ");
		            query.append(" a.room_category>0 and a.event_type='R' and a.no_rooms>0 and ( a.resv_status is null or  a.resv_status<>'PROSPECT') and "); 
		            query.append(" a.event_id=b.resv_name_id(+) ");
		            //query.append(" AND b.room IS NOT NULL ");
		            query.append(" union all "); 
		            query.append(" SELECT TO_CHAR(a.CONSIDERED_DATE,'DD/MM/RRRR') CONSIDERED_DATE,'1' label, a.no_rooms ocupability ");
		            query.append(" FROM reservation_summary a,sc_busblock_info b  ");
		            query.append(" where (a.CONSIDERED_DATE BETWEEN pms_p.business_date and pms_p.business_date+").append(days).append(") and  ");
		            query.append(" a.room_category>0 and a.event_type='B' and a.no_rooms>0 and ( a.resv_status is null or  a.resv_status<>'PROSPECT') and "); 
		            query.append(" a.allotment_header_id=b.busblock_id and b.status<>'F' "); 
	            query.append(" ) t   ");
	            query.append(" group by t.CONSIDERED_DATE,t.label "); 
            query.append(" )t  ");
            query.append(" group by t.business_date,t.categoria  ");
            query.append(" ORDER BY to_date(t.business_date,'DD/MM/RRRR'),t.categoria ");
            
    		stmt=conn.createStatement();  
    		rs=stmt.executeQuery(query.toString());
            
    		StringBuilder detail = new StringBuilder();
    		
    		Integer seq=getCurrentId();
    		
    		System.out.println("INSERT ID = "+seq);
    		
            while(rs.next()){
            	detail.append("(")
            	.append(rs.getInt("n")).append(",")
            	.append("CONVERT(DATETIME,'").append(rs.getString("business_date")).append("',103)").append(",")
            	.append("'").append(rs.getString("categoria")).append("'").append(",")
            	.append(rs.getInt("capacity")).append(",")
            	.append(rs.getInt("ocupability")).append(",")
            	.append(rs.getInt("availability")).append(",")
            	.append("getdate()").append(",")
            	.append("0").append(",")
            	.append(seq)
            	.append("),");
            	
            	if((qty%20)==0){
            		insertAvailability(detail.toString().substring(0, detail.toString().length()-1)+";");
            		detail = new StringBuilder();
            		System.out.println(qty);
            	}
            	qty++;
            }
            if(qty>0){
            	insertAvailability(detail.toString().substring(0, detail.toString().length()-1)+";");
            	detail = new StringBuilder();
            	System.out.println(qty);
            }
        } catch (Exception e) {
        	qty=0;
            throw new RuntimeException(e);
        } finally {
        	if (conn != null) {try {conn.close();} catch (SQLException e) {e.printStackTrace();}}
        	if (stmt != null) {try {stmt.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return qty;
	}
	
	private void insertAvailability(String details)throws Exception{
		Statement stmt=null;
		Connection conn=null;
        try {
        	conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("INSERT INTO dbo.bed_availability(n,business_date,category,capacity,ocupability,availability,auinsertdate,austate,seq_room_availability)VALUES ");
            query.append(details);
            stmt=conn.createStatement();  
    		stmt.executeUpdate(query.toString());
    		
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }finally {
        	if (conn != null) {try {conn.close();} catch (SQLException e) {e.printStackTrace();}}
        	if (stmt != null) {try {stmt.close();} catch (SQLException e) {e.printStackTrace();}}
        }
	}
	
	public Integer enableBedAvailability() throws Exception{
		CallableStatement cs = null;
		Integer deleted=Constante.ID_INICIAL;
        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("{ CALL dbo.update_bed_availability(?) }");
            
            cs = conn.prepareCall(query.toString());
            cs.registerOutParameter(1, java.sql.Types.INTEGER);
            
            cs.execute();
            deleted=cs.getInt(1);
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (cs != null) {try {cs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return deleted;
	}
	
	public Integer getCurrentId(){
		Integer result=Constante.ID_INICIAL; 
		
		PreparedStatement ps=null;
		ResultSet rs=null;

        try {
        	Connection conn = ConnectionFactorySQLAWS.getInstance().getConnection();
            
            StringBuilder query = new StringBuilder();
            query.append("SELECT id_current FROM dbo.seq_room_availability");
            ps = conn.prepareStatement(query.toString());
            
            rs = ps.executeQuery();
            
            if(rs.next()){
            	result=rs.getInt("id_current");
            }
            
        } catch (SQLException e) {
            throw new RuntimeException(e);
        } finally {
        	if (ps != null) {try {ps.close();} catch (SQLException e) {e.printStackTrace();}}
            if (rs != null) {try {rs.close();} catch (SQLException e) {e.printStackTrace();}}
        }
        
        return result;
	}
	
}
