package com.delfines.spring.controller;

import java.util.LinkedList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.Constante;
import com.delfines.business.OperaRoomBo;
import com.delfines.business.UsuarioBo;
import com.delfines.sendmail.SendEmail;
import com.delfines.vo.AvalBedStatus;
import com.delfines.vo.AvalBusinessDate;
import com.delfines.vo.AvalCategoryStatus;
import com.delfines.vo.Usuario;

/**
 * @author imssbora
 */
@Controller
public class OperaRoomController {
   
	
	@RequestMapping(path={"/logout"},method=RequestMethod.GET)
	@ResponseBody
	public ModelAndView logout(Model model,HttpServletRequest request) throws Exception {
		Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
		if(pUsuario!=null&&pUsuario.getIdUsuario()>0){
			request.getSession().removeAttribute("p_usuario");
			UsuarioBo usuarioBo=new UsuarioBo();
			String sessionId=request.getSession().getId();
		    usuarioBo.inactiveSessionId(pUsuario.getIdUsuario(), sessionId);
		}
		request.getSession().removeAttribute("message");
		ModelAndView mv = new ModelAndView("/login");
		return mv;
	}
	
   @RequestMapping(path={"/beds"},method=RequestMethod.GET)
   @ResponseBody
   public ModelAndView beds(Model model,HttpServletRequest request) throws Exception {
	   request.getSession().removeAttribute("message");
	   ModelAndView mv = new ModelAndView("/login");
	   return mv;
   }
	
    @RequestMapping(path={"/view-beds"},method=RequestMethod.GET)
    @ResponseBody
    public ModelAndView viewBedsAvailability(Model model,HttpServletRequest request) {
	   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
	   ModelAndView mv = new ModelAndView("/login");
	 
	   if(pUsuario!=null&&pUsuario.getIdUsuario()>0){
			 
			   UsuarioBo usuarioBo=new UsuarioBo();
			   String userSessionId=usuarioBo.getSessionIdValid(pUsuario.getIdUsuario());//u.session_valid=1 and u.n_access=1
			   if(userSessionId!=null&&userSessionId.trim().length()>0){
				  
					   OperaRoomBo bo=new OperaRoomBo();
					   mv = new ModelAndView("/beds-availability");
					   Integer id=(Integer)request.getSession().getAttribute("id_day");
					   if(id!=null&&id>0){
						   List<AvalBedStatus> lista=new LinkedList<>();
						   lista=bo.listBedsCategoryStatus(id);
						   
						   List<AvalBusinessDate> items=new LinkedList<>();
						   items=bo.listBusinessDateBeds();
						   
						   mv.addObject("lista",lista);
						   mv.addObject("items",items);
					   }else{
						   List<AvalBedStatus> lista=new LinkedList<>();
						   lista=bo.listBedsCategoryStatus();
						   
						   List<AvalBusinessDate> items=new LinkedList<>();
						   items=bo.listBusinessDateBeds();
						   
						   request.getSession().setAttribute("id_day",0);	
						   request.getSession().setAttribute("name_day","");
						   
						   mv.addObject("lista",lista);
						   mv.addObject("items",items);
					   }
					   return mv;
			   
		   }else{
			   mv = new ModelAndView("/login");
			   return mv;
		   }
		   
		 }else{
			 mv = new ModelAndView("/login");
			 return mv;
		 }
    }
	
	
	@RequestMapping(value="/setfilter", method=RequestMethod.GET)
	@ResponseBody
	public Integer setfilter(Integer id,String day,Model model,HttpServletRequest request) {
		try{
			if(id!=null&&id>=0){
				request.getSession().setAttribute("id_day",id);	
				request.getSession().setAttribute("name_day",day);
			}
	    }catch(Exception e){
		   e.printStackTrace();
	    }
	    return id;
	}
	
}