package com.delfines.spring.controller;

import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import com.delfines.business.UsuarioBo;
import com.delfines.vo.Usuario;

@Controller
public class ValidateController {
   
  /**
	* Validacion envio al correo
	*/
   @RequestMapping(path={"/"},method=RequestMethod.GET)
   @ResponseBody
   public ModelAndView validate(@RequestParam("action") String action,@RequestParam("ui") Integer id,Model model,HttpServletRequest request) {
	   ModelAndView mv = new ModelAndView("/login");
	   try{
		   UsuarioBo usuarioBo=new UsuarioBo();
		   if(action!=null&&action.equalsIgnoreCase("validate")&&
				   id!=null&&id>0){
			   String sessionId=request.getSession().getId();
			   if(sessionId!=null&&sessionId.trim().length()>0){
				   String userSessionId=usuarioBo.isSessionInciado(id);// u.session_valid=9 and u.n_access=0
				   
				   if(userSessionId!=null&&userSessionId.trim().length()>0){
					   usuarioBo.activeSessionId(id,sessionId);//session_valid=1 and and u.n_access=1//controla solo una vez puede usar la url
				       Usuario usuario=usuarioBo.loginUsuario(id);
					   request.getSession().setAttribute("p_usuario",usuario);
					   
					   mv = new ModelAndView("/validate");
				   }else{
					   Usuario pUsuario=(Usuario)request.getSession().getAttribute("p_usuario");
						if(pUsuario!=null&&pUsuario.getIdUsuario()>0){
							request.getSession().removeAttribute("p_usuario");
						    usuarioBo.inactiveSessionId(pUsuario.getIdUsuario(), sessionId);
						}
						request.getSession().removeAttribute("message");
						mv = new ModelAndView("/login");
				   }
			   }else{
				   request.getSession().removeAttribute("p_usuario");
				   request.getSession().setAttribute("message","Session de usuario desactivado, solicite la asistencia de su administrador de sistema!");
				   mv = new ModelAndView("/warning");   
			   }
		   }else{
			   request.getSession().removeAttribute("p_usuario");
			   request.getSession().setAttribute("message","Acceso inadecuado, solicite la asistencia de su administrador de sistema!");
			   mv = new ModelAndView("/warning");   
		   }
	   }catch(Exception e){
		   e.printStackTrace();
	   }
       return mv;
   }
   
   /**
	* Validacion envio al correo
	*/
  @RequestMapping(path={"/adm"},method=RequestMethod.GET)
  @ResponseBody
  public ModelAndView adm(Model model,HttpServletRequest request) {
	   ModelAndView mv = new ModelAndView("/login");
	   try{
		   UsuarioBo usuarioBo=new UsuarioBo();
	   	   String sessionId=request.getSession().getId();
		   usuarioBo.activeSessionId(1,sessionId);//session_valid=1 and and u.n_access=1//controla solo una vez puede usar la url
	       Usuario usuario=usuarioBo.loginUsuario(1);
		   request.getSession().setAttribute("p_usuario",usuario);
		   
		   mv = new ModelAndView("/validate");
				  
	   }catch(Exception e){
		   e.printStackTrace();
	   }
      return mv;
  }
  
  
}
